#!/bin/bash
#
#  This file provided to help export of SVN repository for packaging
#
#

usage() {
  echo "SVN export helper"
  echo "Must be run in SVN working copy directory of exported project"
  echo "Usage: $0 <path to directory to export repository to>"
}

if [ $# == 0 ]; then
  usage
  exit 1
fi

EXP=$1

if [ ! -d $EXP ]; then
  echo "Error: $EXP is not a directory"
  usage
  exit 1
fi

CWD=`pwd`
PRJ=`basename $CWD`
echo -n "Exporting $PRJ ... "

svn export . $EXP/$PRJ
if [ $? != 0 ]; then
  exit 1
fi

echo "Exporting svn:externals for $PRJ ... "
x=$((0))
for i in `svn propget svn:externals` ; do
  if [ "$x" == "0" ]; then
    echo -n "  $i ... "
    svn export $i $1/$PRJ/$i
    if [ $? != 0 ]; then
      exit 1
    fi
    x=$((1))
  else
    x=$((0))
  fi
done

exit 0
